## kclock 25.11.80

=== CMakeLists.txt ===
#
# Copyright 2020 Han Young <hanyoung@protonmail.com>
# Copyright 2020-2021 Devin Lin <devin@kde.org>
#
# SPDX-License-Identifier: GPL-2.0-or-later
#

cmake_minimum_required(VERSION 3.16)
set(CMAKE_CXX_STANDARD 17)

# KDE Applications version, managed by release script.
set(RELEASE_SERVICE_VERSION_MAJOR "25")
set(RELEASE_SERVICE_VERSION_MINOR "11")
set(RELEASE_SERVICE_VERSION_MICRO "80")
set(RELEASE_SERVICE_VERSION "${RELEASE_SERVICE_VERSION_MAJOR}.${RELEASE_SERVICE_VERSION_MINOR}.${RELEASE_SERVICE_VERSION_MICRO}")

project(kclock VERSION ${RELEASE_SERVICE_VERSION})

option(BUILD_PLASMOID "Build Plasmoid" ON)

set(KF_MIN_VERSION "6.8.0")
set(QT_MIN_VERSION "6.5.0")

find_package(ECM ${KF_MIN_VERSION} REQUIRED NO_MODULE)

set(CMAKE_MODULE_PATH ${ECM_MODULE_PATH})

# only enable QML debugging on debug builds
set(CMAKE_CXX_FLAGS_DEBUG "${CMAKE_CXX_FLAGS_DEBUG} -DQT_QML_DEBUG ")

include(FeatureSummary)
include(ECMSetupVersion)
include(ECMFindQmlModule)
include(ECMConfiguredInstall)
include(KDEInstallDirs)
include(KDECMakeSettings)
include(KDECompilerSettings NO_POLICY_SCOPE)
include(KDEClangFormat)
include(KDEGitCommitHooks)
include(ECMDeprecationSettings)
include(ECMQtDeclareLoggingCategory)
include(ECMQmlModule)

ecm_setup_version(${PROJECT_VERSION}
    VARIABLE_PREFIX KCLOCK
    VERSION_HEADER ${CMAKE_CURRENT_BINARY_DIR}/version.h
)

find_package(Qt6 ${QT_MIN_VERSION} REQUIRED COMPONENTS
    Core
    Gui
    Quick
    Test
    Svg
    QuickControls2
    Multimedia
    DBus
    WaylandClient
    Widgets
)

find_package(KF6 ${KF_MIN_VERSION} REQUIRED COMPONENTS
    Config
    I18n
    CoreAddons
    Kirigami
    Notifications
    DBusAddons
    Crash
    StatusNotifierItem
    Svg
)
if (BUILD_PLASMOID)
    find_package(KF6 ${KF_MIN_VERSION} REQUIRED COMPONENTS KIO JobWidgets)
    find_package(Plasma REQUIRED)
endif()

find_package(WaylandProtocols 1.21 REQUIRED)

if (Qt6WaylandClient_VERSION VERSION_GREATER_EQUAL "6.10.0")
    find_package(Qt6WaylandClientPrivate ${REQUIRED_QT_VERSION} REQUIRED NO_MODULE)
endif()

find_package(KF6KirigamiAddons 0.6 REQUIRED)

ki18n_install(po)
ecm_set_disabled_deprecation_versions(QT 6.10.0
    KF 6.17.0
)

add_subdirectory(src)

install(PROGRAMS org.kde.kclock.desktop DESTINATION ${KDE_INSTALL_APPDIR})
install(FILES org.kde.kclockd-autostart.desktop DESTINATION ${KDE_INSTALL_AUTOSTARTDIR})
install(FILES org.kde.kclock.appdata.xml DESTINATION ${KDE_INSTALL_METAINFODIR})
install(FILES org.kde.kclock.svg DESTINATION ${KDE_INSTALL_FULL_ICONDIR}/hicolor/scalable/apps/)
install(FILES kclockd.notifyrc DESTINATION ${KDE_INSTALL_KNOTIFYRCDIR})
install(FILES kclock-runner.desktop DESTINATION ${KDE_INSTALL_DATAROOTDIR}/krunner/dbusplugins)

ecm_install_configured_files(INPUT org.kde.kclockd.service.in DESTINATION ${KDE_INSTALL_DBUSSERVICEDIR} @ONLY)

feature_summary(WHAT ALL FATAL_ON_MISSING_REQUIRED_PACKAGES)

# add clang-format target for all our real source files
file(GLOB_RECURSE ALL_CLANG_FORMAT_SOURCE_FILES *.cpp *.h *.hpp)
kde_clang_format(${ALL_CLANG_FORMAT_SOURCE_FILES})
kde_configure_git_pre_commit_hook(CHECKS CLANG_FORMAT)

=== src/kclock/CMakeLists.txt ===
#
# Copyright 2020 Han Young <hanyoung@protonmail.com>
# Copyright 2020-2021 Devin Lin <devin@kde.org>
#
# SPDX-License-Identifier: GPL-2.0-or-later
#

set(kclock_SRCS
    alarm.cpp
    alarm.h
    alarmmodel.cpp
    alarmmodel.h
    timer.cpp
    timer.h
    timermodel.cpp
    timermodel.h
    utilmodel.cpp
    utilmodel.h
    stopwatchtimer.cpp
    stopwatchtimer.h
    kclockformat.cpp
    kclockformat.h
    settingsmodel.cpp
    settingsmodel.h
    stopwatchmodel.cpp
    stopwatchmodel.h
    addlocationmodel.cpp
    addlocationmodel.h
    timerpresetmodel.cpp
    timerpresetmodel.h
    savedlocationsmodel.cpp
    savedlocationsmodel.h
    windowexposure.cpp
    windowexposure.h

    wayland/pipshellsurface.cpp
    wayland/pipshellsurface.h
    pipwindow.cpp
    pipwindow.h
    )

# So we can share the enums.
kconfig_add_kcfg_files(kclock_SRCS ../kclockd/kclockdsettings.kcfgc GENERATE_MOC)
set(SettingsXML ${CMAKE_CURRENT_BINARY_DIR}/../kclockd/org.kde.kclockd.KClockSettings.xml)

set(AlarmXML ${CMAKE_CURRENT_BINARY_DIR}/../kclockd/org.kde.kclockd.Alarm.xml)
set(AlarmModelXML ${CMAKE_CURRENT_BINARY_DIR}/../kclockd/org.kde.kclockd.AlarmModel.xml)
set(TimermModelXML ${CMAKE_CURRENT_BINARY_DIR}/../kclockd/org.kde.kclockd.TimerModel.xml)
set(TimerXML ${CMAKE_CURRENT_BINARY_DIR}/../kclockd/org.kde.kclockd.Timer.xml)
set(UtilityXML ${CMAKE_CURRENT_BINARY_DIR}/../kclockd/org.kde.kclockd.Utility.xml)

qt_add_dbus_interface(kclock_SRCS ${SettingsXML} kclocksettingsinterface )
qt_add_dbus_interface(kclock_SRCS ${AlarmXML} alarminterface )
qt_add_dbus_interface(kclock_SRCS ${AlarmModelXML} alarmmodelinterface )
qt_add_dbus_interface(kclock_SRCS ${TimermModelXML} timermodelinterface )
qt_add_dbus_interface(kclock_SRCS ${TimerXML} timerinterface )
qt_add_dbus_interface(kclock_SRCS ${UtilityXML} utilityinterface )

add_executable(kclock main.cpp ${kclock_SRCS} ${RESOURCES})
add_dependencies(kclock kclockd)

set_source_files_properties(qml/components/PipHandler.qml PROPERTIES QT_QML_SINGLETON_TYPE TRUE)

ecm_add_qml_module(kclock URI org.kde.kclock QML_FILES
    qml/Main.qml

    qml/alarm/AlarmForm.qml
    qml/alarm/AlarmFormPage.qml
    qml/alarm/AlarmListPage.qml
    qml/alarm/AlarmListDelegate.qml
    qml/alarm/AlarmRingingPopup.qml

    qml/components/SoundPickerPage.qml
    qml/components/AboutPage.qml
    qml/components/BottomToolbar.qml
    qml/components/DialogComboBox.qml
    qml/components/FooterToolBarButton.qml
    qml/components/FloatingActionButton.qml
    qml/components/PipHandler.qml
    qml/components/Sidebar.qml
    qml/components/TimePicker.qml
    qml/components/TimePickerSpinBox.qml
    qml/components/TimePickerSpinBoxButton.qml

    qml/timer/PresetDurationButton.qml
    qml/timer/TimerComponent.qml
    qml/timer/TimerForm.qml
    qml/timer/TimerFormDialog.qml
    qml/timer/TimerListDelegate.qml
    qml/timer/TimerListPage.qml
    qml/timer/TimerPage.qml
    qml/timer/TimerRingingPopup.qml

    qml/settings/SettingsPage.qml

    qml/stopwatch/StopwatchPage.qml

    qml/time/AddLocationListView.qml
    qml/time/AddLocationPage.qml
    qml/time/AddLocationWrapper.qml
    qml/time/AnalogClock.qml
    qml/time/AnalogClockHand.qml
    qml/time/TimePage.qml
    qml/time/TimePageDelegate.qml
)

qt6_generate_wayland_protocol_client_sources(kclock
    PRIVATE_CODE
    FILES
        ${CMAKE_CURRENT_SOURCE_DIR}/wayland/xx-pip-v1.xml
        ${WaylandProtocols_DATADIR}/stable/xdg-shell/xdg-shell.xml
        ${Wayland_DATADIR}/wayland.xml
)

target_link_libraries(kclock PRIVATE
    Qt6::Qml
    Qt6::Gui
    Qt6::QuickControls2
    Qt6::WaylandClientPrivate
    Qt6::Widgets
    Qt6::Multimedia
    KF6::I18n
    KF6::ConfigCore
    KF6::ConfigGui
    KF6::CoreAddons
    KF6::DBusAddons
    KF6::Crash
    KF6::I18nQml
    KF6::Svg
)

target_include_directories(kclock PRIVATE ${CMAKE_BINARY_DIR})
install(TARGETS kclock ${KDE_INSTALL_TARGETS_DEFAULT_ARGS})

=== debian/changelog ===
kclock (25.11.80-0ubuntu1) resolute; urgency=medium

  * New upstream (beta) release (25.11.80)
  * Update build-deps and deps with the info from cmake.

 -- Rik Mills <rikmills@kde.org>  Sun, 16 Nov 2025 05:50:55 +0000

kclock (25.08.3-0ubuntu1) resolute; urgency=medium

  * New upstream release (25.08.3)

 -- Rik Mills <rikmills@kde.org>  Thu, 06 Nov 2025 12:12:26 +0000

=== debian/control ===
Source: kclock
Homepage: https://apps.kde.org/kclock/
Maintainer: Kubuntu Developers <kubuntu-devel@lists.ubuntu.com>
XSBC-Original-Maintainer: Yifei Zhan <debian@zhan.science>
Section: kde
Priority: optional
Standards-Version: 4.6.2
Build-Depends: debhelper-compat (= 13),
               dh-sequence-kf6,
               cmake (>= 3.16~),
               extra-cmake-modules (>= 6.8.0~),
               gettext,
               kirigami-addons-dev (>= 0.6~),
               kirigami2-dev,
               libkf6config-dev (>= 6.8.0~),
               libkf6coreaddons-dev (>= 6.8.0~),
               libkf6crash-dev (>= 6.8.0~),
               libkf6dbusaddons-dev (>= 6.8.0~),
               libkf6i18n-dev (>= 6.8.0~),
               libkf6iconthemes-dev,
               libkf6jobwidgets-dev (>= 6.8.0~),
               libkf6kio-dev (>= 6.8.0~),
               libkf6notifications-dev (>= 6.8.0~),
               libkf6statusnotifieritem-dev (>= 6.8.0~),
               libkf6svg-dev (>= 6.8.0~),
               libkirigami-dev (>= 6.8.0~),
               libplasma-dev,
               libqt6svg6-dev,
               qml6-module-org-kde-breeze,
               qml6-module-org-kde-kirigami,
               qml6-module-org-kde-kirigamiaddons-components,
               qml6-module-org-kde-kirigamiaddons-datetime,
               qml6-module-org-kde-kirigamiaddons-delegates,
               qml6-module-org-kde-quickcharts,
               qt6-base-dev (>= 6.5.0~),
               qt6-declarative-dev (>= 6.5.0~),
               qt6-multimedia-dev (>= 6.5.0~),
               qt6-svg-dev (>= 6.5.0~),
               qt6-wayland-dev (>= 6.5.0~),
               qt6-wayland-private-dev,
               qtquickcontrols2-5-dev,
               wayland-protocols (>= 1.21~),
Vcs-Browser: https://code.launchpad.net/~kubuntu-packagers/kubuntu-packaging/+git/kclock
Vcs-Git: https://git.launchpad.net/~kubuntu-packagers/kubuntu-packaging/+git/kclock

Package: kclock
Architecture: any
Depends: ${misc:Depends},
         ${shlibs:Depends},
Description: Clock for KDE Plasma Mobile
 A universal clock application for desktop and mobile. It contains alarm,
 timer, stopwatch and timezone functionalities. Alarms and timers are able to
 wake the device from suspend on Plasma.

## kclock 25.11.90

=== CMakeLists.txt ===
--- 
+++ 
@@ -11,7 +11,7 @@
 # KDE Applications version, managed by release script.
 set(RELEASE_SERVICE_VERSION_MAJOR "25")
 set(RELEASE_SERVICE_VERSION_MINOR "11")
-set(RELEASE_SERVICE_VERSION_MICRO "80")
+set(RELEASE_SERVICE_VERSION_MICRO "90")
 set(RELEASE_SERVICE_VERSION "${RELEASE_SERVICE_VERSION_MAJOR}.${RELEASE_SERVICE_VERSION_MINOR}.${RELEASE_SERVICE_VERSION_MICRO}")
 
 project(kclock VERSION ${RELEASE_SERVICE_VERSION})

=== debian/changelog ===
kclock (25.11.90-0ubuntu1) resolute; urgency=medium

  * New upstream (RC) release (25.11.90)

 -- Rik Mills <rikmills@kde.org>  Fri, 28 Nov 2025 14:02:33 +0000

=== debian/control ===
--- 
+++ 
@@ -5,9 +5,9 @@
 Section: kde
 Priority: optional
 Standards-Version: 4.6.2
-Build-Depends: debhelper-compat (= 13),
+Build-Depends: cmake (>= 3.16~),
+               debhelper-compat (= 13),
                dh-sequence-kf6,
-               cmake (>= 3.16~),
                extra-cmake-modules (>= 6.8.0~),
                gettext,
                kirigami-addons-dev (>= 0.6~),

## kclock 25.12.0

=== CMakeLists.txt ===
--- 
+++ 
@@ -10,8 +10,8 @@
 
 # KDE Applications version, managed by release script.
 set(RELEASE_SERVICE_VERSION_MAJOR "25")
-set(RELEASE_SERVICE_VERSION_MINOR "11")
-set(RELEASE_SERVICE_VERSION_MICRO "90")
+set(RELEASE_SERVICE_VERSION_MINOR "12")
+set(RELEASE_SERVICE_VERSION_MICRO "0")
 set(RELEASE_SERVICE_VERSION "${RELEASE_SERVICE_VERSION_MAJOR}.${RELEASE_SERVICE_VERSION_MINOR}.${RELEASE_SERVICE_VERSION_MICRO}")
 
 project(kclock VERSION ${RELEASE_SERVICE_VERSION})

=== debian/changelog ===
kclock (25.12.0-0zneon+24.04+noble+release+build26) noble; urgency=medium

  * Automatic CI Build

 -- Neon CI <neon@kde.org>  Mon, 08 Dec 2025 10:57:56 +0000

kclock (25.12.0-0neon) noble; urgency=medium

  * New release

 -- Neon CI <neon@kde.org>  Mon, 08 Dec 2025 19:28:56 +1000

## kclock 25.12.0+p24.04+vstable+git20251231.0318

=== debian/changelog ===
kclock (25.12.0+p24.04+vstable+git20251231.0318-0) noble; urgency=medium

  * Automatic Ubuntu CI Build

 -- Neon CI <neon@kde.org>  Wed, 31 Dec 2025 03:18:02 +0000

## kclock 25.12.0+p24.04+vstable+git20260101.0147

=== debian/changelog ===
kclock (25.12.0+p24.04+vstable+git20260101.0147-0) noble; urgency=medium

  * Automatic Ubuntu CI Build

 -- Neon CI <neon@kde.org>  Thu, 01 Jan 2026 01:47:45 +0000

## kclock 25.12.0+p24.04+vunstable+git20251208.1117

=== debian/changelog ===
kclock (25.12.0+p24.04+vunstable+git20251208.1117-0) noble; urgency=medium

  * Automatic Ubuntu CI Build

 -- Neon CI <neon@kde.org>  Mon, 08 Dec 2025 11:17:36 +0000

## kclock 25.12.1

=== CMakeLists.txt ===
--- 
+++ 
@@ -11,7 +11,7 @@
 # KDE Applications version, managed by release script.
 set(RELEASE_SERVICE_VERSION_MAJOR "25")
 set(RELEASE_SERVICE_VERSION_MINOR "12")
-set(RELEASE_SERVICE_VERSION_MICRO "0")
+set(RELEASE_SERVICE_VERSION_MICRO "1")
 set(RELEASE_SERVICE_VERSION "${RELEASE_SERVICE_VERSION_MAJOR}.${RELEASE_SERVICE_VERSION_MINOR}.${RELEASE_SERVICE_VERSION_MICRO}")
 
 project(kclock VERSION ${RELEASE_SERVICE_VERSION})

=== debian/changelog ===
kclock (25.12.1-0zneon+24.04+noble+release+build29) noble; urgency=medium

  * Automatic CI Build

 -- Neon CI <neon@kde.org>  Wed, 21 Jan 2026 23:44:32 +0000

kclock (25.12.1-0neon) noble; urgency=medium

  * New release

 -- Carlos De Maine <carlosd.kde@gmail.com>  Tue, 06 Jan 2026 23:17:15 +1000

## kclock 25.12.1+p24.04+vstable+git20260106.1405

=== debian/changelog ===
kclock (25.12.1+p24.04+vstable+git20260106.1405-0) noble; urgency=medium

  * Automatic Ubuntu CI Build

 -- Neon CI <neon@kde.org>  Tue, 06 Jan 2026 14:05:35 +0000

## kclock 25.12.1+p24.04+vstable+git20260126.1221

=== debian/changelog ===
kclock (25.12.1+p24.04+vstable+git20260126.1221-0) noble; urgency=medium

  * Automatic Ubuntu CI Build

 -- Neon CI <neon@kde.org>  Mon, 26 Jan 2026 12:21:59 +0000

## kclock 25.12.1+p24.04+vstable+git20260130.1031

=== debian/changelog ===
kclock (25.12.1+p24.04+vstable+git20260130.1031-0) noble; urgency=medium

  * Automatic Ubuntu CI Build

 -- Neon CI <neon@kde.org>  Fri, 30 Jan 2026 10:31:51 +0000

## kclock 25.12.1+p24.04+vstable+git20260201.0237

=== debian/changelog ===
kclock (25.12.1+p24.04+vstable+git20260201.0237-0) noble; urgency=medium

  * Automatic Ubuntu CI Build

 -- Neon CI <neon@kde.org>  Sun, 01 Feb 2026 02:37:06 +0000

## kclock 25.12.1+p24.04+vunstable+git20260106.1405

=== debian/changelog ===
kclock (25.12.1+p24.04+vunstable+git20260106.1405-0) noble; urgency=medium

  * Automatic Ubuntu CI Build

 -- Neon CI <neon@kde.org>  Tue, 06 Jan 2026 14:05:32 +0000

=== debian/control ===
Source: kclock
Section: utils
Priority: optional
Build-Depends: cmake,
               debhelper-compat (= 13),
               kf6-extra-cmake-modules,
               kf6-kconfig-dev,
               kf6-kcoreaddons-dev,
               kf6-kcrash-dev,
               kf6-kdbusaddons-dev,
               kf6-ki18n-dev,
               kf6-kio-dev,
               kf6-kirigami-addons-dev,
               kf6-kirigami2-dev,
               kf6-kjobwidgets-dev,
               kf6-knotifications-dev,
               kf6-kstatusnotifieritem-dev,
               libplasma-dev,
               pkg-kde-tools-neon,
               plasma-wayland-protocols,
               qt6-base-dev,
               qt6-declarative-dev,
               qt6-multimedia-dev,
               qt6-svg-dev,
               wayland-protocols
Standards-Version: 4.6.2
Vcs-Git: https://invent.kde.org/neon/neon-packaging/kclock.git
Vcs-Browser: https://invent.kde.org/neon/neon-packaging/kclock
Maintainer: Neon CI <neon@kde.org>

Package: kclock
Architecture: any
Depends: libplasma6,
         qml6-module-org-kde-kirigamiaddons,
         qml6-module-qtquick-shapes,
         ${misc:Depends},
         ${shlibs:Depends}
Description: Clock app for Plasma Mobile
 A plasma mobile clock

## kclock 25.12.1+p24.04+vunstable+git20260129.0441

=== CMakeLists.txt ===
--- 
+++ 
@@ -9,14 +9,19 @@
 set(CMAKE_CXX_STANDARD 17)
 
 # KDE Applications version, managed by release script.
-set(RELEASE_SERVICE_VERSION_MAJOR "25")
-set(RELEASE_SERVICE_VERSION_MINOR "12")
-set(RELEASE_SERVICE_VERSION_MICRO "1")
+set(RELEASE_SERVICE_VERSION_MAJOR "26")
+set(RELEASE_SERVICE_VERSION_MINOR "03")
+set(RELEASE_SERVICE_VERSION_MICRO "70")
 set(RELEASE_SERVICE_VERSION "${RELEASE_SERVICE_VERSION_MAJOR}.${RELEASE_SERVICE_VERSION_MINOR}.${RELEASE_SERVICE_VERSION_MICRO}")
 
 project(kclock VERSION ${RELEASE_SERVICE_VERSION})
 
 option(BUILD_PLASMOID "Build Plasmoid" ON)
+
+option(KCLOCK_BUILD_SHELL_OVERLAY "Enable building of lockscreen overlay functionality" ON)
+if (KCLOCK_BUILD_SHELL_OVERLAY)
+    add_definitions(-DKCLOCK_BUILD_SHELL_OVERLAY)
+endif() # KCLOCK_BUILD_SHELL_OVERLAY
 
 set(KF_MIN_VERSION "6.8.0")
 set(QT_MIN_VERSION "6.5.0")
@@ -95,7 +100,9 @@
 install(FILES org.kde.kclock.appdata.xml DESTINATION ${KDE_INSTALL_METAINFODIR})
 install(FILES org.kde.kclock.svg DESTINATION ${KDE_INSTALL_FULL_ICONDIR}/hicolor/scalable/apps/)
 install(FILES kclockd.notifyrc DESTINATION ${KDE_INSTALL_KNOTIFYRCDIR})
-install(FILES kclock-runner.desktop DESTINATION ${KDE_INSTALL_DATAROOTDIR}/krunner/dbusplugins)
+
+# Flatpak exports needs the desktop file to be the app ID
+install(FILES kclock-runner.desktop DESTINATION ${KDE_INSTALL_DATAROOTDIR}/krunner/dbusplugins RENAME org.kde.kclock.desktop)
 
 ecm_install_configured_files(INPUT org.kde.kclockd.service.in DESTINATION ${KDE_INSTALL_DBUSSERVICEDIR} @ONLY)

=== src/kclock/CMakeLists.txt ===
--- 
+++ 
@@ -35,6 +35,10 @@
 
     wayland/pipshellsurface.cpp
     wayland/pipshellsurface.h
+    wayland/WaylandAboveLockscreen.cpp
+    wayland/WaylandAboveLockscreen.h
+    utils/LockscreenUtils.cpp
+    utils/LockscreenUtils.h
     pipwindow.cpp
     pipwindow.h
     )
@@ -69,6 +73,7 @@
     qml/alarm/AlarmListPage.qml
     qml/alarm/AlarmListDelegate.qml
     qml/alarm/AlarmRingingPopup.qml
+    qml/alarm/AlarmLockscreenPopup.qml
 
     qml/components/SoundPickerPage.qml
     qml/components/AboutPage.qml
@@ -112,6 +117,32 @@
         ${Wayland_DATADIR}/wayland.xml
 )
 
+
+if (KCLOCK_BUILD_SHELL_OVERLAY)
+    find_package(Qt6 ${QT_MIN_VERSION} CONFIG REQUIRED Gui WaylandClient)
+
+    if (Qt6Gui_VERSION VERSION_GREATER_EQUAL "6.10.0")
+        find_package(Qt6 REQUIRED COMPONENTS GuiPrivate WaylandClientPrivate)
+    else()
+        find_package(Qt6Gui ${QT_MIN_VERSION} CONFIG REQUIRED Private)
+        find_package(Qt6WaylandClient ${QT_MIN_VERSION} COMPONENTS CONFIG REQUIRED Private)
+    endif()
+
+    find_package(Wayland REQUIRED)
+    find_package(PlasmaWaylandProtocols 1.8 CONFIG)
+    find_package(KF6 ${KF_MIN_VERSION} REQUIRED COMPONENTS WindowSystem)
+    set_package_properties(PlasmaWaylandProtocols PROPERTIES
+        TYPE REQUIRED
+        PURPOSE "Collection of Plasma-specific Wayland protocols"
+        URL "https://invent.kde.org/libraries/plasma-wayland-protocols/"
+    )
+    find_package(QtWaylandScanner)
+    set_package_properties(QtWaylandScanner PROPERTIES
+        TYPE REQUIRED
+        PURPOSE "Required for building with Wayland above-lock-screen support"
+    )
+
+endif() # KCLOCK_BUILD_SHELL_OVERLAY
 target_link_libraries(kclock PRIVATE
     Qt6::Qml
     Qt6::Gui
@@ -129,5 +160,24 @@
     KF6::Svg
 )
 
+if(KCLOCK_BUILD_SHELL_OVERLAY)
+    
+    target_link_libraries(kclock PRIVATE
+        Qt6::GuiPrivate
+        Qt6::WaylandClient
+        Wayland::Client
+        KF6::WindowSystem
+    )
+
+    if (Qt6_VERSION VERSION_GREATER_EQUAL "6.8.0")
+        set(private_code_option  "PRIVATE_CODE")
+    endif()
+
+    qt6_generate_wayland_protocol_client_sources(kclock FILES
+        ${PLASMA_WAYLAND_PROTOCOLS_DIR}/kde-lockscreen-overlay-v1.xml
+        ${private_code_option}
+    )
+
+endif() # KCLOCK_BUILD_SHELL_OVERLAY
 target_include_directories(kclock PRIVATE ${CMAKE_BINARY_DIR})
 install(TARGETS kclock ${KDE_INSTALL_TARGETS_DEFAULT_ARGS})

=== src/kclockd/CMakeLists.txt ===
#
# Copyright 2020 Han Young <hanyoung@protonmail.com>
# Copyright 2020 Devin Lin <espidev@gmail.com>
# Copyright 2025 Tushar Gupta <tushar.197712@gmail.com>
#
# SPDX-License-Identifier: GPL-2.0-or-later
#

set(kclockd_SRCS
    utilities.cpp
    utilities.h
    alarm.cpp
    alarm.h
    alarmmodel.cpp
    alarmmodel.h
    alarmwaitworker.cpp
    alarmwaitworker.h
    alarmplayer.cpp
    alarmplayer.h
    kclockrunner.cpp
    kclockrunner.h
    timermodel.cpp
    timermodel.h
    timer.cpp
    timer.h
    xdgportal.cpp
    xdgportal.h
    abstractwakeupprovider.h
    powerdevilwakeupprovider.cpp
    powerdevilwakeupprovider.h
    unitylauncher.cpp
    unitylauncher.h
    waittimerwakeupprovider.cpp
    waittimerwakeupprovider.h

    utils/ScreenSaverUtils.h
    utils/ScreenSaverUtils.cpp
    )
# generate KConfig class from xml
kconfig_add_kcfg_files(kclockd_SRCS kclockdsettings.kcfgc GENERATE_MOC)

# use generated KConfig header file to generate DBus adaptor xml
set(kclockd_SRCS
    ${kclockd_SRCS}
    ${CMAKE_CURRENT_BINARY_DIR}/org.kde.kclockd.KClockSettings.xml
)

qt_generate_dbus_interface(
    ${CMAKE_CURRENT_BINARY_DIR}/kclockdsettings.h
    org.kde.kclockd.KClockSettings.xml
    OPTIONS -S -P
)
qt_generate_dbus_interface(
    ${CMAKE_CURRENT_SOURCE_DIR}/alarm.h
    org.kde.kclockd.Alarm.xml
    OPTIONS -s -m -P
)
qt_generate_dbus_interface(
    ${CMAKE_CURRENT_SOURCE_DIR}/alarmmodel.h
    org.kde.kclockd.AlarmModel.xml
    OPTIONS -s -m
)
qt_generate_dbus_interface(
    ${CMAKE_CURRENT_SOURCE_DIR}/timermodel.h
    org.kde.kclockd.TimerModel.xml
    OPTIONS -s -m -p
)

qt_generate_dbus_interface(
    ${CMAKE_CURRENT_SOURCE_DIR}/timer.h
    org.kde.kclockd.Timer.xml
    OPTIONS -s -m -P
)

qt_generate_dbus_interface(
    ${CMAKE_CURRENT_SOURCE_DIR}/utilities.h
    org.kde.kclockd.Utility.xml
    OPTIONS -s -m -P
)
# use generated DBus adapator xml to generate adaptor source code
qt_add_dbus_adaptor(kclockd_SRCS ${CMAKE_CURRENT_BINARY_DIR}/org.kde.kclockd.KClockSettings.xml
                     kclockdsettings.h KClockSettings)
qt_add_dbus_adaptor(kclockd_SRCS ${CMAKE_CURRENT_BINARY_DIR}/org.kde.kclockd.Alarm.xml
                     alarm.h Alarm)
qt_add_dbus_adaptor(kclockd_SRCS ${CMAKE_CURRENT_BINARY_DIR}/org.kde.kclockd.AlarmModel.xml
                     alarmmodel.h AlarmModel)
qt_add_dbus_adaptor(kclockd_SRCS ${CMAKE_CURRENT_BINARY_DIR}/org.kde.kclockd.TimerModel.xml
                     timermodel.h TimerModel)
qt_add_dbus_adaptor(kclockd_SRCS ${CMAKE_CURRENT_BINARY_DIR}/org.kde.kclockd.Timer.xml
                     timer.h Timer)
qt_add_dbus_adaptor(kclockd_SRCS ${CMAKE_CURRENT_BINARY_DIR}/org.kde.kclockd.Utility.xml
                     utilities.h Utilities)

qt_add_dbus_interface(kclockd_SRCS systeminterfaces/org.mpris.MediaPlayer2.Player.xml generated/systeminterfaces/mprisplayer)
qt_add_dbus_adaptor(kclockd_SRCS systeminterfaces/org.kde.krunner1.xml kclockrunner.h KClockRunner)

# install DBus interface xml to dbus interface directory
install(FILES ${CMAKE_CURRENT_BINARY_DIR}/org.kde.kclockd.KClockSettings.xml DESTINATION ${KDE_INSTALL_DBUSINTERFACEDIR})
install(FILES ${CMAKE_CURRENT_BINARY_DIR}/org.kde.kclockd.Alarm.xml DESTINATION ${KDE_INSTALL_DBUSINTERFACEDIR})
install(FILES ${CMAKE_CURRENT_BINARY_DIR}/org.kde.kclockd.AlarmModel.xml DESTINATION ${KDE_INSTALL_DBUSINTERFACEDIR})
install(FILES ${CMAKE_CURRENT_BINARY_DIR}/org.kde.kclockd.TimerModel.xml DESTINATION ${KDE_INSTALL_DBUSINTERFACEDIR})
install(FILES ${CMAKE_CURRENT_BINARY_DIR}/org.kde.kclockd.Timer.xml DESTINATION ${KDE_INSTALL_DBUSINTERFACEDIR})
install(FILES ${CMAKE_CURRENT_BINARY_DIR}/org.kde.kclockd.Utility.xml DESTINATION ${KDE_INSTALL_DBUSINTERFACEDIR})

add_executable(kclockd main.cpp ${kclockd_SRCS} )
target_link_libraries(kclockd PRIVATE
    Qt6::Multimedia
    Qt6::Widgets
    KF6::I18n
    KF6::ConfigCore
    KF6::ConfigGui
    KF6::CoreAddons
    KF6::Notifications
    KF6::DBusAddons
    KF6::StatusNotifierItem
    KF6::Crash
)

ecm_qt_declare_logging_category(kclockd HEADER debug_timermodel.h
    IDENTIFIER TIMERMODEL_DEBUG
    CATEGORY_NAME org.kde.kclockd.timermodel
    DESCRIPTION "KClockd TimerModel"
)

ecm_qt_declare_logging_category(kclockd HEADER debug_runner.h
    IDENTIFIER RUNNER_DEBUG
    CATEGORY_NAME org.kde.kclock.runner
    DESCRIPTION "KClock Runner"
)

target_include_directories(kclockd PRIVATE ${CMAKE_BINARY_DIR})
install(TARGETS kclockd ${KDE_INSTALL_TARGETS_DEFAULT_ARGS})

=== debian/changelog ===
kclock (25.12.1+p24.04+vunstable+git20260129.0441-0) noble; urgency=medium

  * Automatic Ubuntu CI Build

 -- Neon CI <neon@kde.org>  Thu, 29 Jan 2026 04:41:49 +0000

## kclock 25.12.1+p24.04+vunstable+git20260201.0758

=== debian/changelog ===
kclock (25.12.1+p24.04+vunstable+git20260201.0758-0) noble; urgency=medium

  * Automatic Ubuntu CI Build

 -- Neon CI <neon@kde.org>  Sun, 01 Feb 2026 07:58:23 +0000

## kclock 25.12.2

=== CMakeLists.txt ===
--- 
+++ 
@@ -9,19 +9,14 @@
 set(CMAKE_CXX_STANDARD 17)
 
 # KDE Applications version, managed by release script.
-set(RELEASE_SERVICE_VERSION_MAJOR "26")
-set(RELEASE_SERVICE_VERSION_MINOR "03")
-set(RELEASE_SERVICE_VERSION_MICRO "70")
+set(RELEASE_SERVICE_VERSION_MAJOR "25")
+set(RELEASE_SERVICE_VERSION_MINOR "12")
+set(RELEASE_SERVICE_VERSION_MICRO "2")
 set(RELEASE_SERVICE_VERSION "${RELEASE_SERVICE_VERSION_MAJOR}.${RELEASE_SERVICE_VERSION_MINOR}.${RELEASE_SERVICE_VERSION_MICRO}")
 
 project(kclock VERSION ${RELEASE_SERVICE_VERSION})
 
 option(BUILD_PLASMOID "Build Plasmoid" ON)
-
-option(KCLOCK_BUILD_SHELL_OVERLAY "Enable building of lockscreen overlay functionality" ON)
-if (KCLOCK_BUILD_SHELL_OVERLAY)
-    add_definitions(-DKCLOCK_BUILD_SHELL_OVERLAY)
-endif() # KCLOCK_BUILD_SHELL_OVERLAY
 
 set(KF_MIN_VERSION "6.8.0")
 set(QT_MIN_VERSION "6.5.0")
@@ -100,9 +95,7 @@
 install(FILES org.kde.kclock.appdata.xml DESTINATION ${KDE_INSTALL_METAINFODIR})
 install(FILES org.kde.kclock.svg DESTINATION ${KDE_INSTALL_FULL_ICONDIR}/hicolor/scalable/apps/)
 install(FILES kclockd.notifyrc DESTINATION ${KDE_INSTALL_KNOTIFYRCDIR})
-
-# Flatpak exports needs the desktop file to be the app ID
-install(FILES kclock-runner.desktop DESTINATION ${KDE_INSTALL_DATAROOTDIR}/krunner/dbusplugins RENAME org.kde.kclock.desktop)
+install(FILES kclock-runner.desktop DESTINATION ${KDE_INSTALL_DATAROOTDIR}/krunner/dbusplugins)
 
 ecm_install_configured_files(INPUT org.kde.kclockd.service.in DESTINATION ${KDE_INSTALL_DBUSSERVICEDIR} @ONLY)

=== debian/changelog ===
kclock (25.12.2-0ubuntu3) resolute; urgency=medium

  * Rebuild for Plasma 6.6.

 -- Rik Mills <rikmills@kde.org>  Mon, 02 Mar 2026 08:25:37 +0000

kclock (25.12.2-0ubuntu2) resolute; urgency=medium

  * No-change rebuild for Qt 6.10.2 private ABI.

 -- Rik Mills <rikmills@kde.org>  Sun, 15 Feb 2026 12:53:20 +0000

kclock (25.12.2-0ubuntu1) resolute; urgency=medium

  * New upstream release (25.12.2)

 -- Rik Mills <rikmills@kde.org>  Thu, 05 Feb 2026 12:20:49 +0000

kclock (25.12.1-0ubuntu2) resolute; urgency=medium

  * No-change rebuild for kf6-kio 6.22.1.

 -- Rik Mills <rikmills@kde.org>  Thu, 22 Jan 2026 21:48:38 +0000

kclock (25.12.1-0ubuntu1) resolute; urgency=medium

  * New upstream release (25.12.1)

 -- Rik Mills <rikmills@kde.org>  Thu, 08 Jan 2026 11:00:57 +0000

kclock (25.12.0-0ubuntu1) resolute; urgency=medium

  * New upstream release (25.12.0)

 -- Rik Mills <rikmills@kde.org>  Thu, 11 Dec 2025 12:18:10 +0000

=== debian/control ===
Source: kclock
Homepage: https://apps.kde.org/kclock/
Maintainer: Kubuntu Developers <kubuntu-devel@lists.ubuntu.com>
XSBC-Original-Maintainer: Yifei Zhan <debian@zhan.science>
Section: kde
Priority: optional
Standards-Version: 4.6.2
Build-Depends: cmake (>= 3.16~),
               debhelper-compat (= 13),
               dh-sequence-kf6,
               extra-cmake-modules (>= 6.8.0~),
               gettext,
               kirigami-addons-dev (>= 0.6~),
               kirigami2-dev,
               libkf6config-dev (>= 6.8.0~),
               libkf6coreaddons-dev (>= 6.8.0~),
               libkf6crash-dev (>= 6.8.0~),
               libkf6dbusaddons-dev (>= 6.8.0~),
               libkf6i18n-dev (>= 6.8.0~),
               libkf6iconthemes-dev,
               libkf6jobwidgets-dev (>= 6.8.0~),
               libkf6kio-dev (>= 6.8.0~),
               libkf6notifications-dev (>= 6.8.0~),
               libkf6statusnotifieritem-dev (>= 6.8.0~),
               libkf6svg-dev (>= 6.8.0~),
               libkirigami-dev (>= 6.8.0~),
               libplasma-dev (>= 6.6.1),
               libqt6svg6-dev,
               qml6-module-org-kde-breeze,
               qml6-module-org-kde-kirigami,
               qml6-module-org-kde-kirigamiaddons-components,
               qml6-module-org-kde-kirigamiaddons-datetime,
               qml6-module-org-kde-kirigamiaddons-delegates,
               qml6-module-org-kde-quickcharts,
               qt6-base-dev (>= 6.5.0~),
               qt6-declarative-dev (>= 6.5.0~),
               qt6-multimedia-dev (>= 6.5.0~),
               qt6-svg-dev (>= 6.5.0~),
               qt6-wayland-dev (>= 6.5.0~),
               qt6-wayland-private-dev,
               qtquickcontrols2-5-dev,
               wayland-protocols (>= 1.21~),
Vcs-Browser: https://code.launchpad.net/~kubuntu-packagers/kubuntu-packaging/+git/kclock
Vcs-Git: https://git.launchpad.net/~kubuntu-packagers/kubuntu-packaging/+git/kclock

Package: kclock
Architecture: any
Depends: ${misc:Depends},
         ${shlibs:Depends},
Description: Clock for KDE Plasma Mobile
 A universal clock application for desktop and mobile. It contains alarm,
 timer, stopwatch and timezone functionalities. Alarms and timers are able to
 wake the device from suspend on Plasma.
